#include <string.h> /* For memcmp() */

#include "connection.hh"

bool Connection::operator== (const Connection &conn) const
{
    if(DestPort != conn.DestPort)return false;
    if(Protocol != conn.Protocol)return false;
    if(AddrLen != conn.AddrLen)return false;
    if(memcmp(&Addr, &conn.Addr, AddrLen) != 0)return false;
    return true;
}

bool Connection::operator< (const Connection &conn) const
{
    if(DestPort < conn.DestPort)return true;
    if(DestPort > conn.DestPort)return false;
    if(Protocol < conn.Protocol)return true;
    if(Protocol > conn.Protocol)return false;
    if(AddrLen < conn.AddrLen)return true;
    if(AddrLen > conn.AddrLen)return false;
    
    int c = memcmp(&Addr, &conn.Addr, AddrLen);
    if(c < 0)return true;
    
    return false;
}
